//+------------------------------------------------------------------+
//|                                   Ultimate COT Net Positions.mq4 |
//|   Copyright  2009, C-4 (Vasiliy Sokolov, Russia, St.-Petersburg,|
//|                                      2009), All Rights Reserved. |
//|                                                   vs-box@mail.ru |
//+------------------------------------------------------------------+

//   COT-Index

#property copyright "Copyright  2009, C-4 (Vasiliy Sokolov, SPb), All Rights Reserved."
#property link      "vs-box@mail.ru"

#property indicator_separate_window
#property  indicator_buffers 4
#property  indicator_color1  Lime
#property  indicator_color2  Lime
#property  indicator_color3  Red
#property  indicator_color4  Yellow

//extern int  period=156;
//int movement_index=6;

extern bool Show_traders_noncomm_long=true;
extern bool Show_traders_noncomm_short=false;
extern bool Show_traders_operators_long=true;
extern bool Show_traders_operators_short=false;

double traders_noncomm_long[];
double traders_noncomm_short[];
double traders_operators_long[];
double traders_operators_short[];

#include <cotlib_mod_01.mq4>

int init()
{
period=156;
movement_index=6;
   if(init_data()==false)error=-1;
   if(error==0)load_data();
   if(error==0)count_data();
   //if(error==false)count_index(period);
   SetParam();
}

int start()
{
   if(error==-1)Print("init_data() error");
   DrowData();
}

void SetParam()
{
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(1,DRAW_LINE,STYLE_DOT,1);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID,1);
   SetIndexStyle(3,DRAW_LINE,STYLE_DOT,1);
   IndicatorDigits(0);
   SetIndexEmptyValue(0,EMPTY_VALUE);
   SetIndexEmptyValue(1,EMPTY_VALUE);
   SetIndexEmptyValue(2,EMPTY_VALUE);
   SetIndexEmptyValue(3,EMPTY_VALUE);
   SetLevelValue(0,0.0);
   ///SetLevelValue(1,20.0);
   //SetLevelValue(2,80.0);
   //SetLevelValue(3,100.0);
   SetLevelStyle(STYLE_DOT,0,Silver);
   //SetLevelStyle(0,1,Black);
   //SetLevelStyle(0,1,Black);
   //SetLevelStyle(0,1,Black);
   if(load_cot_file==true)IndicatorShortName(StringConcatenate("Meta COT Traders (",period,"): ",str_trim(cot_file)));
   else IndicatorShortName(StringConcatenate("Meta COT Traders (",period,"): ",name));
   if(Show_traders_noncomm_long==true){
      SetIndexBuffer(0,traders_noncomm_long);
      SetIndexLabel(0, "Traders noncomm long");
   }
   if(Show_traders_noncomm_short==true){
      SetIndexBuffer(1,traders_noncomm_short);
      SetIndexLabel(1,"Traders noncomm short");
   }
   if(Show_traders_operators_long==true){
      SetIndexBuffer(2,traders_operators_long);
      SetIndexLabel(2,"Traders operators long");
   } 
   if(Show_traders_operators_short==true){
      SetIndexBuffer(3,traders_operators_short);
      SetIndexLabel(3,"Traders operators short");
   }
}
//#define TR_NONCOMM_LONG       30
//#define TR_NONCOMM_SHORT      31
//#define TR_OPERATORS_LONG     32
//#define TR_OPERATORS_SHORT    33
void DrowData()
{
   int end_data=get_lastdata();
   for(int i=0;i<end_data;i++){
      if(Show_traders_noncomm_long)traders_noncomm_long[i]=get_data(TR_NONCOMM_LONG, i)-get_data(TR_NONCOMM_SHORT, i);
      if(Show_traders_noncomm_short)traders_noncomm_short[i]=get_data(TR_NONCOMM_SHORT, i);
      if(Show_traders_operators_long)traders_operators_long[i]=get_data(TR_OPERATORS_LONG, i)-get_data(TR_OPERATORS_SHORT,i);
      if(Show_traders_operators_short)traders_operators_short[i]=get_data(TR_OPERATORS_SHORT,i);
   }
}